@echo --- Free MC Boot loader v1.93 installation ---

:: sign the kelf for memory card
@echo Signing boot kelf...
@ps3mca-tool.exe -k fmcb-install\FMCB.KELF fmcb-install\SFMCB.KELF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to sign boot kelf
	@goto end)

:: create all needed dirs
@echo Creating necessary directories...
@ps3mca-tool.exe -mkdir /BOOT > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to create 'BOOT' directory
	@goto end)
@ps3mca-tool.exe -mkdir /BAEXEC-SYSTEM > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to create 'BAEXEC-SYSTEM' directory
	@goto end)
@ps3mca-tool.exe -mkdir /BEEXEC-SYSTEM > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to create 'BEEXEC-SYSTEM' directory
	@goto end)
@ps3mca-tool.exe -mkdir /BIEXEC-SYSTEM > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to create 'BIEXEC-SYSTEM' directory
	@goto end)
@ps3mca-tool.exe -mkdir /SYS-CONF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to create 'SYS-CONF' directory
	@goto end)

:: copy the signed kelf to mc
@echo Copying signed boot kelf...
@ps3mca-tool.exe -in fmcb-install\SFMCB.KELF /BOOT/SFMCB.KELF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy signed kelf
	@goto end)

:: write all required files
@echo Copying default configuration file...
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\FREEMCB.CNF /SYS-CONF/FREEMCB.CNF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy default connfiguration file
	@goto end)
@echo Copying FMCB configurator...
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\FMCB_CFG.ELF /SYS-CONF/FMCB_CFG.ELF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy FMCB configurator
	@goto end)
@echo Copying USB modules...
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\USBD.IRX /SYS-CONF/USBD.IRX > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'USBD.IRX'
	@goto end)
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\USBHDFSD.IRX /SYS-CONF/USBHDFSD.IRX > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'USBHDFSD.IRX'
	@goto end)
@echo Copying FMCB icons...
@ps3mca-tool.exe -in fmcb-install\BREXEC-SYSTEM\icon.sys /BAEXEC-SYSTEM/icon.sys > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'icon.sys'
	@goto end)
@ps3mca-tool.exe -in fmcb-install\BREXEC-SYSTEM\FMCB.icn /BAEXEC-SYSTEM/FMCB.icn > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'FMCB.icn'
	@goto end)
@echo Copying BOOT folder icons...
@ps3mca-tool.exe -in fmcb-install\BOOT\icon.sys /BOOT/icon.sys > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'icon.sys'
	@goto end)
@ps3mca-tool.exe -in fmcb-install\BOOT\BOOT.icn /BOOT/BOOT.icn > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'BOOT.icn'
	@goto end)
@echo Copying SYS-CONF folder icons...
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\icon.sys /SYS-CONF/icon.sys > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'icon.sys'
	@goto end)
@ps3mca-tool.exe -in fmcb-install\SYS-CONF\sysconf.icn /SYS-CONF/sysconf.icn > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy 'sysconf.icn'
	@goto end)

:: write external homebrew apps
@echo Copying uLaunchElf...
@ps3mca-tool.exe -in fmcb-install\BOOT\BOOT.ELF /BOOT/BOOT.ELF > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to copy uLaunchElf
	@goto end)

:: now crosslink dummy files to kelf to make multi region/model hack
@echo Cross-linking files for multi region/model installation...
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BAEXEC-SYSTEM/osd120.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BAEXEC-SYSTEM/osd130.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BAEXEC-SYSTEM/osdmain.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BEEXEC-SYSTEM/osd130.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BEEXEC-SYSTEM/osdmain.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BIEXEC-SYSTEM/osdsys.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BIEXEC-SYSTEM/osd110.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BIEXEC-SYSTEM/osd120.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BIEXEC-SYSTEM/osd130.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BOOT/SFMCB.KELF /BIEXEC-SYSTEM/osdmain.elf > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'SFMCB.KELF'
	@goto end)
@ps3mca-tool.exe -cl /BAEXEC-SYSTEM/icon.sys /BEEXEC-SYSTEM/icon.sys > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'icon.sys'
	@goto end)
@ps3mca-tool.exe -cl /BAEXEC-SYSTEM/FMCB.icn /BEEXEC-SYSTEM/FMCB.icn > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'FMCB.icn'
	@goto end)
@ps3mca-tool.exe -cl /BAEXEC-SYSTEM/icon.sys /BIEXEC-SYSTEM/icon.sys > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'icon.sys'
	@goto end)
@ps3mca-tool.exe -cl /BAEXEC-SYSTEM/FMCB.icn /BIEXEC-SYSTEM/FMCB.icn > nul
@if ERRORLEVEL 1 (
	@echo ERROR: failed to cross-link 'FMCB.icn'
	@goto end)

@echo Installation complete!

:end
@pause
